# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin
import sys, json
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
try:
    from urlparse import urlparse, parse_qs
except ImportError:
    from urllib.parse import urlparse, parse_qs
import ifvod


def resp(ret, recur=False):
    if 'code' in ret:
        if 'error' in ret:
            return xbmcgui.Dialog().ok('Error: ' + ret['code'], ret['error'])
        return xbmcgui.Dialog().ok('Error', ret['code'])
    if isinstance(ret, list):
        xbmcplugin.setContent(handle, 'videos')
        for elem in ret:
            resp(elem, True)
        return xbmcplugin.endOfDirectory(handle)
    assert isinstance(ret, dict)
    if 'title' not in ret:
        for k, v in ret.items():
            if isinstance(v, list):
                ret = {'title': k, 'json': json.dumps(v)}
            else:
                ret = {'title': k, 'url': v}
    li = xbmcgui.ListItem(ret['title'])
    if 'img' in ret:
        li.setArt({'thumb': ret['img']})
    if 'plot' in ret:
        li.setInfo('video', {'plot': ret['plot']})
    t = True
    if 'url' in ret:
        if isinstance(ret['url'], list):
            ret['url'] = 'stack://' + ' , '.join(ret['url'])
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            return xbmc.Player().play(ret['url'], li)
        o = urlparse(ret['url'])
        p = o.path.split('/')
        ext = p[-1].split('.')[-1]
        if ext in ('m3u', 'm3u8', 'mp4'):
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            return xbmc.Player().play(ret['url'], li)
        if t:
            t = sub1(ret['url'])
    for k, v in ret.items():
        try:
            ret[k] = v.encode('utf-8')
        except:
            pass
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(ret), li, t)


def sub1(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if o.netloc == 'train.ifvod.tv' and l > 1 and p[1] == 'play':
        return False
    return True


def sub2(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if o.netloc == 'train.ifvod.tv':
        if l > 1 and p[1] == 'detail':
            return resp(ifvod.detail(url))
        if l > 1 and p[1] == 'play':
            return resp(ifvod.play(url))
    return resp({'code': 'ifvod 020', 'error': url})


def sub3(content):
    try:
        data = json.loads(content)
    except Exception as e:
        return resp({'code': 'ifvod 030', 'error': str(e)})
    resp(data)


def category(cat):
    if 'page' in q:
        page = int(q['page'][0])
    else:
        page = 1
    resp(ifvod.category(cat, page))


def search(s):
    if not s:
        kb = xbmc.Keyboard(heading='Search')
        kb.doModal()
        if not kb.isConfirmed():
            return
        s = kb.getText()
    if 'page' in q:
        page = int(q['page'][0])
    else:
        page = 1
    resp(ifvod.search(s, page))


handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
    resp({'title': u'电影', 'category': '0,1,3'})
    resp({'title': u'连续剧', 'category': '0,1,4'})
    resp({'title': u'综艺', 'category': '0,1,5'})
    resp({'title': u'动漫', 'category': '0,1,6'})
    resp({'title': u'纪录片', 'category': '0,1,7'})
    resp({'title': u'Search', 'search': ''})
    xbmcplugin.endOfDirectory(handle)
else:
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'json' in q:
        sub3(q['json'][0])
    elif 'url' in q:
        sub2(q['url'][0])
    elif 'category' in q:
        category(q['category'][0])
    elif 'search' in q:
        search(q['search'][0])
